default:
  image: docker:19.03.12-dind

services:
  - docker:19.03.12-dind

before_script:
  - docker info
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY

variables:
  DOCKER_TLS_CERTDIR: ""
  DOCKER_DRIVER: overlay2
  TERRAFORM_VERSION: $CI_JOB_NAME

.docker_build: &docker_build
  - docker build --pull -t $CI_REGISTRY_IMAGE:$TERRAFORM_VERSION --build-arg TERRAFORM_VERSION=$TERRAFORM_VERSION .
  - docker push $CI_REGISTRY_IMAGE:$TERRAFORM_VERSION

stages:
  - lint
  - build
  - release

lint:dockerfiles:
  stage: lint
  image: hadolint/hadolint:latest-debian
  before_script:
      - hadolint --version
  script:
      - hadolint --config .hadolint.yaml ./Dockerfile
  allow_failure: true

0.13.6:
  stage: build
  only:
    - main
  script:
    - *docker_build

0.14.5:
  stage: build
  only:
    - main
  script:
    - *docker_build

0.14.8:
  stage: build
  only:
    - main
  script:
    - *docker_build

latest:
  stage: release
  only:
    - main
  variables:
    TARGET_VERSION: 0.14.5
    TARGET_IMAGE: $CI_REGISTRY_IMAGE:$TARGET_VERSION
  script:
    - docker pull $TARGET_IMAGE
    - docker tag $TARGET_IMAGE $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest
